"use strict";
;(function() {

var active;
var mainpane;
let nodelocations = {};
var enclosureData = {};
var racks = [];
var noderange = "";
var nodedivs = {};
var currdivs = [];
var minvalue;
var maxvalue;
var rackLoc = {}; //SH
var rackRowLoc = {}; //SH
var MaxRack = 1; //SH

var curroverlay = null;

var weightedambient = [
    [17, 240],
    [22.5, 120],
    [31.5, 60],
    [45, 0],
];

var overlaysensors = {
    'Ambient Temperature': {
        'sensors': [ 'ambient_temp' ],
        'scale': weightedambient,
    },
    'CPU 1 Temperature': {
        'sensors': [ 'cpu_1_temp' ],
        'scale': null,
    },
    'CPU 2 Temperature': {
        'sensors': [ 'cpu_2_temp' ],
        'scale': null,
    },
    'Power': {
        'sensors': [ 'sys_power' ],
        'scale': null,
    },
};
var overlayselect;



var fetchdata;

// function maketoolbar() {
//     var toolrow = document.createElement('ul');
//     toolrow.classList.add('toolbar', 'header');
//     /*
//     toolrow.appendChild(maketoollabel(l('Select') + ":"));
//     var selections = createSelection(['', 'All', 'None', 'Invert']);
//     selections.classList.add('tool');
//     toolrow.appendChild(maketoollabel(l('Next Boot') + ":"));
//     selections = createSelection(['', 'default', 'network', 'cd', 'disk']);
//     selections.classList.add('tool');
//     toolrow.appendChild(selections);
//     */
//     // var healthmenu = addToolMenu(toolrow, 'Filter by health', 'medkit');
//     // addMenuItem(healthmenu, 'Critical', filterHealth.bind(['critical', 'failed']), 'times-circle');
//     // addMenuItem(healthmenu, 'Warning', filterHealth.bind(['warning', 'critical', 'failed']), 'exclamation-triangle');
//     // addMenuItem(healthmenu, 'All', filterHealth.bind(['ok', 'warning', 'critical', 'failed']), 'check-square');
//     // var powerMenu = addToolMenu(toolrow, 'Power', 'power-off'); 
//     // addMenuItem(powerMenu, 'Off', globalPower.bind('off'), 'power-off');
//     // addMenuItem(powerMenu, 'Boot', globalPower.bind('boot'), 'refresh');
//     // addMenuItem(powerMenu, 'Shutdown', globalPower.bind('shutdown'), 'bed');
//     // toolrow.appendChild(maketoollabel(l('Noderange:')));
//     // var nrinput = document.createElement('input');
//     // nrinput.value = noderange;
//     // nrinput.classList.add('tool');
//     // nrinput.addEventListener('input', newnoderange.bind(nrinput));
//     // toolrow.appendChild(nrinput);
//     // var terms = addToolMenu(toolrow, 'Terminals', 'desktop');
//     // addMenuItem(terms, 'Open Multiple Consoles', openAllTerms.bind('/console/session'), 'desktop');
//     // addMenuItem(terms, 'Open Multiple Shells', openAllTerms.bind('/shell/sessions/'), 'terminal');
//     // addMenuItem(terms, 'Close All Terminals', CloseTerminals, 'close');
//     // addMenuItem(terms, 'Arrange', TileTerminals, 'th', true);
//     // var resize = function() { ScaleTerminals(this); }
//     // addMenuItem(terms, 'Shrink', resize.bind(0.8), 'minus-square', true);
//     // addMenuItem(terms, 'Reset Size', resize.bind(1), 'square', true);
//     // addMenuItem(terms, 'Enlarge', resize.bind(1.2), 'plus-square', true);
//     // //addMenuItem(terms, 'Type Everywhere', toggleBroadcast, 'keyboard-o');
//     // bkitem = addMenuItem(toolrow, 'Type in all Terminals', toggleBroadcast, 'keyboard-o');
//     // bkitem.classList.add('navitem');


//     return toolrow;
// }

function getNodeInfo(range){  //get info for all nodes

    nodelocations = {};
    enclosureData = {};
    racks = [];
rackLoc = {}; //SH
rackRowLoc = {}; //SH
MaxRack = 1; //SH 

	if(range == null){   // either not sent a range originally, or this is being called a second time
        if(noderange == null || noderange == ""){   // if noderange has already been set, just keep it
            noderange = 'everything';               // noderange hasn't been set yet and it wasn't passed, so set to everything
        }
	}else{
        noderange = range;
    }
	getRequest('/confluent-api/noderange/' + noderange + '/attributes/current', parseNodeInfo,  donull, undefined, undefined, true);
}

function parseNodeInfo(json){  // parse info for all nodes -- rack, location, etc
    var skipnodes = "";


    if(json.databynode != null){
        var data = json.databynode;

        if(!Array.isArray(data)){  // make sure data is an array
            data = [data];
        }

        nodelocations = {};  // nodelocations is a dictionary of node objects, indexed by node name
        var needheight = {};

        // Start parsing...
        data.forEach(function(nodeData){   // ex of nodeData...  "n12": { "console.method": {"value": "ipmi"} }

            // First, get the node name....
            for(var node in nodeData){  // node holds the node's name. Not sure why this is the only way to get it. Only one iteration.

                // Next, make a new node object for this node if it doesn't already exist
                if (!(node in nodelocations)) {  // ensures uniqueness
                    var newNodeObject = {'height': 1};
                    needheight[node] = 1;
                    nodelocations[node] = newNodeObject;  // each unique node has its own node object within nodelocations, indexed by the node's name (node)
                }

                // Now, go through each attribute and parse
                // Within each loop, nodeData contains one attribute. Access it with nodeData[node]
                var attribute = nodeData[node];
                // If we care about this attribute, add it to the nodelocations array
                if ('enclosure.bay' in attribute) {
                    // get bays in the same format (deal with 6R/6L for example)
                    var bay = attribute['enclosure.bay']['value'];
                    var bayNum = 0;

                    if(bay.indexOf("L") > -1){  // format 6L
                        bay.replace("L", "");
                        bayNum = parseInt(bay);
                        bayNum = bayNum * 2 - 1;  // so 2L will be 2*2-1 = bay 3, etc
                    }else if(bay.indexOf("R") > -1){  // format 6R
                        bay.replace("R", "");
                        bayNum = parseInt(bay);
                        bayNum = bayNum * 2;    // so 2R will be 2*2 = bay 4, etc
                    }else{
                        bayNum = parseInt(bay);
                    }
                    nodelocations[node]['bay'] = bayNum;
                }

		 if ('enclosure.manager' in attribute) {
                    nodelocations[node]['enclosure'] = attribute['enclosure.manager']['value'];
                    if (nodelocations[attribute['enclosure.manager']['value']] != undefined){ //SH
                                nodelocations[node]['rack'] =  nodelocations[attribute['enclosure.manager']['value']]['rack']; //SH
                                nodelocations[node]['u'] =  nodelocations[attribute['enclosure.manager']['value']]['u']; //SH
                                nodelocations[attribute['enclosure.manager']['value']]['M'] = 1; //SH DEFINGING A MANAGER
                    } //SH
                }

                if ('location.rack' in attribute ) {
		    if (attribute['location.rack']['value'] != ""){ //SH 
				  nodelocations[node]['rack'] = attribute['location.rack']['value'];

			}//SH 		
                    // add to rack array
                    var rackVal = attribute['location.rack']['value'];
                    if(rackVal != null && rackVal != undefined && rackVal != "" && racks.indexOf(rackVal) < 0){
                        racks.push(rackVal);
                    }
                }

                if ('location.u' in attribute) {
			if (attribute['location.u']['value'] != ""){ //SH 
                    		nodelocations[node]['u'] = attribute['location.u']['value'];
			}//SH
                }
                var currrow;
                if ('location.row' in attribute) {
                    currrow = attribute['location.row']['value'];
                } else {
                    currrow = '';
                }
                    nodelocations[node]['row'] = currrow;
			if (nodelocations[node]['rack'] != undefined){//SH-
				rackLoc[ nodelocations[node]['rack'] ] = currrow; //SH
			}//SH


                if ('location.height' in attribute) {
                    delete needheight[node];
                    nodelocations[node]['height'] = attribute['location.height']['value'];
                    skipnodes = skipnodes + ',-' + node;
                }
            }
        });
    }

    if (Object.keys(needheight).length == 0) {
        getEnclosures();
    } else {
        getHeightInfo(skipnodes);
    }
}

function getHeightInfo(append){
    getRequest('/confluent-api/noderange/' + noderange + append + '/description', parseHeightInfo,  donull, undefined, undefined, true);
}

function parseHeightInfo(json){

    if(json.databynode != null){
        var data = json.databynode;

        if(!Array.isArray(data)){  // make sure data is an array
            data = [data];
        }

        // Start parsing...
        data.forEach(function(nodeData){

            // First, get the node name....
            for(var node in nodeData){  // node holds the node's name.

                // Make sure previous call for all other data happened for this node
                if (!(node in nodelocations)) {  // ensures uniqueness
                    // TODO: error
                    console.log("Node " + node + " does not exist");
                    continue;
                }

                var description = nodeData[node];
                

                if('height' in description){
                    nodelocations[node]['height'] = description['height'];
                }

            }


        });

    }

    getEnclosures();

    // getEnclosures();
}

function getEnclosures(){
    var e = []; //SH

    for (var node in nodelocations){  //cycle through all nodes to look at their enclosure data

        var enclosure = nodelocations[node]["enclosure"];   // get enclosure name

        if(enclosure != null && enclosure != undefined && enclosure != ""){    // node is part of an enclosure

            if(!(enclosure in enclosureData)){  // new enclosure
                enclosureData[enclosure] = {};
                enclosureData[enclosure]["nodes"] = [];    // array of node names within enclosure
                enclosureData[enclosure]["nodes"].push(node);
                enclosureData[enclosure]["maxBay"] = nodelocations[node]["bay"];
                enclosureData[enclosure]["rack"] = nodelocations[node]["rack"];
                enclosureData[enclosure]["u"] = nodelocations[node]["u"];
            }else{   // we've seen this enclosure already
                var maxBay = enclosureData[enclosure]["maxBay"];   // update maxBay if needed
                var currBay = nodelocations[node]["bay"];
                if(currBay > maxBay){
                    enclosureData[enclosure]["maxBay"] = currBay;
                }

                enclosureData[enclosure]["nodes"].push(node);
            }

        }
	if (nodelocations[node]["rack"] == undefined){//SH
		if (!e.includes(nodelocations[node]["enclosure"]) && nodelocations[node]["enclosure"] != undefined){//SH
			e.push(nodelocations[node]["enclosure"]);//SH
		}//SH
	}//SH
    }
	var range = "";//SH
	for (var i=0; i<e.length; i++){//SH
		range += e[i] + ",";//SH
	}//SH
	if (range != ""){//SH
		getRequest('/confluent-api/noderange/' + range + '/attributes/current', testfn,  donull, undefined, undefined, true); //.bind(nodelocations, racks)//SH
	} else { //SH


    // if(validateEnclosures()){
        // getHeightInfo();
        drawRacks();
        drawEnclosures(); 
        colorNodes();
    // }

    //drawEnclosures();
	} //SH

}
function testfn(json){
        nodelocations;
	racks;
	var nodes = [];
        for(var node in nodelocations){
        	if (nodelocations[node]["enclosure"] != undefined){
                	if (nodelocations[node]["rack"] == undefined){
                        	nodes.push(node);
                        }
                }
        }
    	if(json.databynode != null){
               	var data = json.databynode;
		var skipnodes = "";
       		if(!Array.isArray(data)){  // make sure data is an array
      			 data = [data];
        	}
        	for(var m in data){ //nodeData
			var attribute = data[m];
			for (var a in attribute){
				if ('location.rack' in attribute[a] ) {
                                	if (attribute[a]['location.rack']['value'] != ""){
                                        	for(var node in nodelocations){
                                                	if (nodelocations[node]["enclosure"] == a){
                                                        	nodelocations[node]['rack'] = attribute[a]['location.rack']['value'];
                                                	}
                                        	}
						racks.push(attribute[a]['location.rack']['value']);
				rackLoc[ nodelocations[node]['rack'] ] = nodelocations[node]["row"]; //SH- ADDED

						if (!(a in nodelocations)) {  // ensures uniqueness
							var newNodeObject = {'M': 1};
							nodelocations[a] = newNodeObject;  
						}
						nodelocations[a]['rack'] = attribute[a]['location.rack']['value'];
						enclosureData[a]['rack'] = attribute[a]['location.rack']['value'];
						nodelocations[a]['height'] = Math.ceil(enclosureData[a]['maxBay']/2.0);

                                	}
                        	} else if ('location.u' in attribute[a] ) {
                                        if (attribute[a]['location.u']['value'] != ""){
                                                for(var node in nodelocations){
                                                        if (nodelocations[node]["enclosure"] == a){
                                                                nodelocations[node]['u'] = attribute[a]['location.u']['value'];
                                                        }
                                                }
						if (!(a in nodelocations)) {  // ensures uniqueness
                                                        var newNodeObject = {'M': 1, 'height': 1};
                                                        nodelocations[a] = newNodeObject;
                                                }
						nodelocations[a]['u'] = attribute[a]['location.u']['value']; 
						enclosureData[a]['u'] = attribute[a]['location.u']['value'];
                                        }
                                } else if ('location.row' in attribute[a]){ //SH- ADDED
					 nodelocations[a]['row'] = attribute[a]['location.row']['value'];
					 rackLoc[nodelocations[a]["rack"]] = attribute[a]['location.row']['value'];
				} //SH- ADDED
			}
            	}
       }
	drawRacks();
        drawEnclosures();
        colorNodes();
	
}

function validateEnclosures(){    // for each enclosure, verify that all nodes within enclosure have correct data. If not, update.

    for(var enc in enclosureData){

        // First make sure rack and u are consistent

        // get rack and u of first node from this enclosure
        var rack = enclosureData[enc]["rack"];
        var u = enclosureData[enc]["u"];

        if(rack == null){
            fixEnclosureData(enc, "rack", "");
            return false;
        }
        if(u == null){
            fixEnclosureData(enc, "u", "");
            return false;
        }

        
        for(var index in enclosureData[enc]["nodes"]){

            var node = enclosureData[enc]["nodes"][index];

            var nodeLoc = nodelocations[node];

            var thisRack = nodeLoc["rack"];
            var thisU = nodeLoc["u"];

            if(thisRack != rack){
                fixEnclosureData(enc, "rack", rack);
                return false;
            }
            if(thisU != u){
                fixEnclosureData(enc, "u", u);
                return false;
            }


            // make sure no other nodes are in the same bay
            var thisBay = nodeLoc["bay"];

            for(var index2 in enclosureData[enc]["nodes"]){

                if(index != index2){  // don't compare to itself

                    var node2 = enclosureData[enc]["nodes"][index2];
                    var bay2 = nodelocations[node2]["bay"];

                    if(bay2 == thisBay){    // 2 in one bay... fix

                        fixBays(enc, node, node2, thisBay);
                        return false;
                    }

                }
            }


        }

    }

    return true;

}

function fixEnclosureData(enclosure, rackOrU, suggestedVal){   

    var encDlg = document.createElement('div');      // create dialog div
    encDlg.classList.add('modaldialog');
    encDlg.classList.add('centered');

    var heading = encDlg.appendChild(document.createElement("span"));
    heading.classList.add("noteHeader");
    heading.innerHTML = "Rack Data for " + enclosure;

    var headBreak = encDlg.appendChild(document.createElement("span"));
    headBreak.innerHTML = "<br/>";


    // content

    var textContent = "";
    if(rackOrU.toLowerCase() == "rack"){
        textContent = "Rack locations for enclosure " + enclosure + " do not agree. <br/>Please enter correct rack location.";
    }else if (rackOrU.toLowerCase() == "u"){
        textContent = "U locations for enclosure " + enclosure + " do not agree. <br/>Please enter correct U location.";
    }

    var content = encDlg.appendChild(document.createElement("span"));
    content.innerHTML = textContent;
    content.appendChild(document.createElement("br"));
    content.appendChild(document.createElement("br"));

    var input = document.createElement('input');
    input.id = rackOrU;
    if(suggestedVal != null) input.value = suggestedVal;
    var label = document.createElement('label');
    label.setAttribute('for', input.id);
    label.textContent =  capitalize(rackOrU.toLowerCase()) + ':';
    content.appendChild(label);
    content.appendChild(input);
    content.appendChild(document.createElement('br'));

    // set up rest of dialog

    var bg = document.createElement('div');
    bg.classList.add('modalbg');
    document.body.appendChild(bg);
    bg.appendChild(encDlg);
    encDlg.appendChild(document.createElement('hr'));
    var save = document.createElement('button');
    save.textContent = l('Save');
    save.addEventListener('click', closeDialog.bind([encDlg, bg, function(){updateEnclosure(enclosure, rackOrU.toLowerCase(), input.value);}]));
    encDlg.appendChild(save);
    var cancelbtn = document.createElement('button');
    cancelbtn.textContent = l('Cancel');
    cancelbtn.addEventListener('click', closeDialog.bind([encDlg, bg, false]));
    encDlg.appendChild(cancelbtn);

}

function updateEnclosure(enclosure, field, value){

    var url = "/confluent-api/noderange/" + enclosureData[enclosure]["nodes"].join(",") + "/attributes/all";
    var data;

    if(field == "rack"){
        data = { "location.rack" : value };
    }else if(field == "u"){
        data = { "location.u" : value};
    }

    putRequest(url, data, reload);
}

function fixBays(enclosure, node1, node2, bay){

    var bayDlg = document.createElement('div');      // create dialog div
    bayDlg.classList.add('modaldialog');
    bayDlg.classList.add('centered');

    var heading = bayDlg.appendChild(document.createElement("span"));
    heading.classList.add("noteHeader");
    heading.innerHTML = "Rack Data for " + enclosure;

    var headBreak = bayDlg.appendChild(document.createElement("span"));
    headBreak.innerHTML = "<br/>";


    // content

    var textContent = "Nodes " + node1 + " and " + node2 + " are both in bay " + bay + " of enclosure " + enclosure + ". <br/>Please enter the correct bays.";

    var content = bayDlg.appendChild(document.createElement("span"));
    content.innerHTML = textContent;
    content.appendChild(document.createElement("br"));
    content.appendChild(document.createElement("br"));

    // bay for node1
    var bayinput1 = document.createElement('input');
    bayinput1.id = node1;
    if(bay != null && bay != undefined && bay != "") bayinput1.value = bay;
    var label1 = document.createElement('label');
    label1.setAttribute('for', bayinput1.id);
    label1.textContent =  node1 + ':';
    content.appendChild(label1);
    content.appendChild(bayinput1);
    content.appendChild(document.createElement('br'));

    //bay for node2
    var bayinput2 = document.createElement('input');
    bayinput2.id = node2;
    if(bay != null && bay != undefined && bay != "") bayinput2.value = bay;
    var label2 = document.createElement('label');
    label2.setAttribute('for', bayinput2.id);
    label2.textContent =  node2 + ':';
    content.appendChild(label2);
    content.appendChild(bayinput2);
    content.appendChild(document.createElement('br'));


    // set up rest of dialog
    var bg = document.createElement('div');
    bg.classList.add('modalbg');
    document.body.appendChild(bg);
    bg.appendChild(bayDlg);
    bayDlg.appendChild(document.createElement('hr'));
    var save = document.createElement('button');
    save.textContent = l('Save');
    save.addEventListener('click', closeDialog.bind([bayDlg, bg, function(){updateBays(node1, bayinput1.value, node2, bayinput2.value);}]));
    bayDlg.appendChild(save);
    var cancelbtn = document.createElement('button');
    cancelbtn.textContent = l('Cancel');
    cancelbtn.addEventListener('click', closeDialog.bind([bayDlg, bg, false]));
    bayDlg.appendChild(cancelbtn);

}

function updateBays(node1, bay1, node2, bay2){

    var url1 = "/confluent-api/nodes/" + node1 + "/attributes/all";
    var data1 = { "enclosure.bay" : bay1 };

    var url2 = "/confluent-api/nodes/" + node2 + "/attributes/all";
    var data2 = { "enclosure.bay" : bay2 };

    putRequest(url1, data1, donull);
    putRequest(url2, data2, reload);
}


function capitalize(word){
    return word.charAt(0).toUpperCase() + word.substr(1);
}

function drawEnclosures(){
    for(var enc in enclosureData){
        var enclosure = enclosureData[enc];

        var rack = enclosure["rack"];
        var u = parseInt(enclosure["u"]);
        var maxBay = enclosure["maxBay"];
        var height = 0;

        if(maxBay != null && maxBay != undefined && maxBay != ""){
            var height = Math.ceil(maxBay/2.0);
        }

        if(rack != null && rack != undefined && rack != "" && u != null && u != undefined && u != ""){
            for(var i = 0; i < height; i++){
                var row = document.getElementById("rackTable_" + rack + "_" + (u+i));
                if (row != null && row != undefined){
                    row.childNodes[1].classList.add("enclosure");
                    row.childNodes[2].classList.add("enclosure");
                }
            }
        }
    }

    addNodes();
}

function drawRacks(){

    while (mainpane.firstChild) {
        mainpane.removeChild(mainpane.firstChild);
    }
	//SH ADDED
	var rowSet = new Set();
	for (var item in rackLoc){
		rowSet.add(rackLoc[item]);
	}
	for (var item of rowSet){
		rackRowLoc[item] = [];
	}
	for (var item in rackLoc){
		rackRowLoc[rackLoc[item]].push(item);
	}	
	for (var i in rackRowLoc){
		rackRowLoc[i].sort();
		if (rackRowLoc[i].length > MaxRack){
			MaxRack = rackRowLoc[i].length;
		}
	}
	

	var newRacks = [];
	for ( var i in rackRowLoc){
		for(var j in rackRowLoc[i]){
			newRacks.push(rackRowLoc[i][j]);
		}
	}
	racks =  newRacks;
	racks.sort(function(a,b){return a.localeCompare(b, undefined, { numeric: true, sensitivity: 'base'})});
	


	var truemainpane = document.getElementById('main');
	var siblingpane1 = truemainpane.previousElementSibling;
	var siblingpane2 = truemainpane.previousElementSibling.previousElementSibling;
/*

	var siblinsgparent = document.createElement('div');
	siblinsgparent.classList.add("sticky");
	siblinsgparent.appendChild(siblingpane2);
	siblinsgparent.appendChild(siblingpane1);

	truemainpane.insertAdjacentElement('beforebegin', siblinsgparent); 
*/

// TEST */
	var truemainpane = document.getElementById('main');
	var childpane = truemainpane.lastChild;
	var midpane = document.createElement('div');
	//SH2 midpane.style.width = 422 * MaxRack + "px";	
	childpane.appendChild(midpane);
	
	//SH2 midpane.classList.add("scroller");//TESH	
	
 	//SH2 midpane.parentNode.style.whiteSpace = "nowrap";

	//SH2 midpane.parentNode.style.overflowX = "scroll";
	//SH2 midpane.parentNode.style.height = "calc(89vh)";
	
	var body = document.getElementsByTagName("body")[0];
	//SH2 body.style.overflow = "hidden"; 


	//-- SH ADDED

    racks.forEach(function(rack){ //racks.sort().forEach //SH Modified
        var newRack = drawRackTable(rack);
	midpane.appendChild(newRack);    //mainpane.appendChild(newRack); //SH Modified
    });
	
	//SH ADDED
	for(var i in rackRowLoc){
 	        var list = document.getElementsByClassName("row" + i);
    	   	var newItem = document.createElement("div");
       		var textnode = document.createTextNode("row" + i);
		newItem.appendChild(textnode);

		var sortbutton = document.createElement('button');
		sortbutton.textContent = l('Ascending Row ' + i);

		sortbutton.classList.add('btn'+i);
		
		sortbutton.style.display = "block";
		
		sortbutton.addEventListener('click', sortrow.bind(sortbutton));
		if (list[0] !=  undefined){
			list[0].insertAdjacentElement('beforebegin', sortbutton);
		}
	}

	//SH2 for (var i in rackLoc){
		//SH2 document.getElementsByClassName("row" + rackLoc[i])[0].style.clear = "both";
	//SH2 }
	//-- SH ADDED

    //getEnclosures();
}

function drawRackTable(rackID){
    var table = document.createElement("table");
    table.id = "rackTable_" + rackID;
    table.classList.add("rackTable");

	table.classList.add("row" + rackLoc[rackID]); //SH

    var tableHead = table.appendChild(document.createElement("thead"));
    var header = tableHead.appendChild(document.createElement("th"));
    header.colspan = "3";
    header.innerHTML = "Rack " + rackID;
    header.classList.add("rackTableHead");

    var tableBody = table.appendChild(document.createElement("tbody"));
    var rackheight = localStorage.getItem('rackheight');
    if (!rackheight) { rackheight = 50; }
    for(var i = rackheight; i > 0; i--){
        var newRow = tableBody.appendChild(document.createElement("tr"));
        newRow.id = table.id + "_" + i;
        newRow.classList.add("rackTableChild");

        var u = newRow.appendChild(document.createElement("td"));
        u.innerHTML = "" + i;
        u.classList.add("rackTableChild", "racku");

        var left = newRow.appendChild(document.createElement("td"));
        left.id = newRow.id + "_" + 1;
        left.innerHTML = "&nbsp;";
        left.classList.add("rackTableChild", "rackLeft");

        var right = newRow.appendChild(document.createElement("td"));
        right.id = newRow.id + "_" + 2;
        right.innerHTML = "&nbsp;";
        right.classList.add("rackTableChild", "rackRight");
    }

    return table;
}

function addNodes(){
    var occupiedCells = [];
    var groupedLeftCells = {}; //SH
    var groupedRightCells = {} //SH
    var groupedRows = {}; //SH

    for(var node in nodelocations){  // cycle through all nodes and place them in racks
        var rack = nodelocations[node]["rack"];
        var u = nodelocations[node]["u"];
        var enclosure = nodelocations[node]["enclosure"];
        var bay = nodelocations[node]["bay"];
        var height = parseInt(nodelocations[node]["height"]);

        if (height == null || height == undefined || isNaN(height)){ //SH ADDED NaN
            height = 1;
        }


        if(rack != undefined && rack != null && rack != "" && u != undefined && u != null && u != ""){

            if(enclosure != undefined && enclosure != null && enclosure != ""){   // part of an enclosure -- need to look at bay, not u

                if(bay == undefined || bay == null || bay == ""){  // error
                    showAlert.bind('')(1, "Error: Node " + node + " cannot be mapped because it is assigned to an enclosure but not to a bay.");
                }else{  // figure out what space the bay corresponds to
                    // get offset from the bottom of the enclosure
                    var offset = Math.ceil(bay/2) - 1;
                    var u_offset = parseInt(u) + offset;

                    // figure out left or right side -- if odd (bay % 2 = 1) it's the left side, otherwise it's right
                    var side = bay % 2 > 0 ? 1 : 2;

                    // var cell = document.getElementById("rackTable_" + rack + "_" + u_offset + "_" + side);


                    var currentCells = [];    // cell ids of all cells occupied by the node. might be more than one.
                    // currentCells.push(cell);

                    // add all filled cells based on height attribute
                    var valid = true;
                    for (var i=0; i<height; i++){
                        var cell = document.getElementById("rackTable_" + rack + "_" + (u_offset + i) + "_" + side);
                        if (cell != null && cell != undefined){
                            currentCells.push(cell);
                        }else{
                            // TODO: some kind of error
                            console.log("Cell doesn't exist: " + "rackTable_" + rack + "_" + (u_offset + i) + "_" + side +
                                "\nSkipping node " + node);
                            valid = false;
                            break;
                        }
                    }

                    if(!valid){   // don't draw this node at all if any of its cells didn't exist
                        continue;
                    }

                    //cell.innerHTML = node;
                    // if(cell != null && cell != undefined)

                    var occupied = false;
                    for (var index in currentCells){
                        var cell = currentCells[index];
                        if (occupiedCells.includes(cell.id)){
                            occupied = true;
                            // TODO: some kind of error
                            console.log(cell);
                            console.log("Cell " + cell.id + " already occupied");
                            break;
                        }
                    } 

                    if (occupied){   // at least one cell was already occupied; skip this node
                        // TODO: some kind of error
                        console.log("Cell " + cell.id + " already occupied");
                        continue;

                    }else{   // nothing occupied, can place node

                        for(var index in currentCells){
                            var cell = currentCells[index];
                            occupiedCells.push(cell.id);    // mark these cells as occupied
                        }
                            
                        var mergedCell = mergeCells_Rows(currentCells);                

                        if(mergedCell != null && mergedCell != undefined){
                            var span0 = mergedCell.appendChild(document.createElement("span"));
                            var span1 = mergedCell.appendChild(document.createElement("span"));
                            span0.innerHTML = node;
                            mergedCell.classList.add("racknode");
                            nodedivs[node] = mergedCell;
                        }else{
                            console.log("Merged cell does not exist");
                        }
                    }
                    
                }

            }else{   // not part of an enclosure. Only need to look at rack and u.

                var currentCells = [];    // cell ids of all cells occupied by the node. might be more than one.
                // currentCells.push(cell);

               // add all filled cells based on height attribute
               u = parseInt(u);
                var valid = true;

                for (var i=0; i<height; i++){
                    var cell = document.getElementById("rackTable_" + rack + "_" + (u + i) + "_1");
                    var adjCell = document.getElementById("rackTable_" + rack + "_" + (u + i) + "_2");

                    if (cell != null && cell != undefined){    // make sure cell exists
                        currentCells.push(cell);
                    }else{
                        // TODO: some kind of error
                        console.log("Cell doesn't exist: " + "rackTable_" + rack + "_" + (u + i) + "_1" +
                            "\nSkipping node " + node);
                        valid = false;
                        break;
                    }

                    // make sure adjacent cell exists -- these span whole rack (2 cells)
                    if (adjCell != null && adjCell != undefined){    // make sure adjacent cell exists
                        currentCells.push(adjCell);
                    }else{
                        // TODO: some kind of error
                        console.log("Cell doesn't exist: " + "rackTable_" + rack + "_" + (u + i) + "_2" +
                            "\nSkipping node " + node);
                        valid = false;
                        break;
                    }
                }
		
                if(!valid){   // don't draw this node at all if any of its cells didn't exist
                    continue;
                }






                // make sure nothing occupied already

                var occupied = false;
                for (var index in currentCells){
                    var cell = currentCells[index];
                    if (occupiedCells.includes(cell.id)){
                        occupied = true;
                        // TODO: some kind of error
                        console.log(cell);
                        console.log("Cell " + cell.id + " already occupied");
                        break;
                    }
                } 

                if (occupied && nodelocations[node]['M'] == undefined /*SH ADDED*/ ){   // at least one cell was already occupied; skip this node
                    // TODO: some kind of error
                    console.log("Cell " + cell.id + " already occupied");
                    continue;

                }else{   // nothing occupied, can place node

  		if (nodelocations[node]['M'] == undefined){ //SH

                    for(var index in currentCells){
                        var cell = currentCells[index];
                        occupiedCells.push(cell.id);    // mark these cells as occupied
                    }
                    
                    // merge columns in each row first
                    var fullRows = [];
                    for(var index in currentCells){
                        var cell = currentCells[index];
                        if(cell.id.charAt(cell.id.length -1 ) == "1"){   // left side of rack
                           var mergedRow = mergeCells_Columns(cell);
                            if(mergedRow != null && mergedRow != undefined){
                                fullRows.push(mergedRow);
                            }
                        }
                    }

                    var mergedCell = mergeCells_Rows(fullRows);
			            

                    if(mergedCell != null && mergedCell != undefined){
                        var span0 = mergedCell.appendChild(document.createElement("span"));
                        var span1 = mergedCell.appendChild(document.createElement("span"));
                        span0.innerHTML = node;
                        mergedCell.classList.add("racknode");
                        nodedivs[node] = mergedCell;
                    }else{
                        console.log("Merged cell does not exist");
                    }

		}//SH
		//SH ADDED---------------------------------------
		else {
			groupedLeftCells[node] = [];
			groupedRightCells[node] = [];
			groupedRows[node] = [];
			for (var i=0; i<height; i++){
				var row = document.getElementById("rackTable_" + rack + "_" + (u + i));
				var cell = document.getElementById("rackTable_" + rack + "_" + (u + i) + "_1");
				var adjCell = document.getElementById("rackTable_" + rack + "_" + (u + i) + "_2");
			
				if (row != null && row != undefined){    // make sure cell exists
                	                groupedRows[node].push("rackTable_" + rack + "_" + (u + i));
                       		}
				if (cell != null && cell != undefined){    // make sure cell exists
        				groupedLeftCells[node].push("rackTable_" + rack + "_" + (u + i) + "_1");
				}
				if (adjCell != null && adjCell != undefined){    // make sure cell exists
        				groupedRightCells[node].push("rackTable_" + rack + "_" + (u + i) + "_2");
				}
			}	
			//document.getElementById(groupedRows[node][0]).style.borderBottom = "thick solid";
			document.getElementById(groupedRows[node][0]).children[1].style.borderBottom = "medium solid black";			
                        document.getElementById(groupedRows[node][0]).children[2].style.borderBottom = "medium solid black";
			

			//document.getElementById(groupedRows[node][groupedRows[node].length-1]).style.borderTop = "thick solid";
			document.getElementById(groupedRows[node][groupedRows[node].length-1]).children[1].style.borderTop = "medium solid black";
                        document.getElementById(groupedRows[node][groupedRows[node].length-1]).children[2].style.borderTop = "medium solid black";

			for (var i=0; i<groupedRightCells[node].length; i++){
				document.getElementById(groupedRightCells[node][i]).style.borderRight = "medium solid black";
			}
                        for (var i=0; i<groupedLeftCells[node].length; i++){
                                document.getElementById(groupedLeftCells[node][i]).style.borderLeft = "medium solid black";
                        }
		}
		//SH ADDED----------------------------------------
  	  	}
	      }              
            
        }else{  // error
            showAlert.bind('')(1, "Error: Node " + node + " cannot be mapped because it is missing a rack location.");
        }
    }
}


function mergeCells_Rows(cells){

    var cellsToDelete = [];   // keep track of which cells to delete in merge
    var height = cells.length;
    var topCell;

    for(var i=0; i<height; i++){
        var cell = cells[i];

        if(i == (height - 1)){   // top cell of node
            topCell = cell;
            cell.rowSpan = height;
        }else{
            cellsToDelete.push(cell);
        }
    }

    for(var index in cellsToDelete){   // delete remaining cells
        var cell = cellsToDelete[index];
        cell.parentNode.removeChild(cell);
    }

    return topCell;

}


function mergeCells_Columns(leftCell){    // cell is left half
    // delete last cell and make this cell span 2 columns

    if(leftCell == null || leftCell == undefined){
        console.log("Cell doesn't exist");
        return null;
    }

    if(leftCell.id.charAt(leftCell.id.length - 1) != "1"){    // didn't send the correct side
        var newID = leftCell.id.substring(0, leftCell.id.length - 1) + "1";
        leftCell = document.getElementById(newID);
        if(leftCell == null || leftCell == undefined){
            console.log("Cell doesn't exist: " + newID);
            return null;
        }
    }

    var row = leftCell.parentNode;
    if(row.childNodes.length > 2){
        row.deleteCell(2); 
    } 
    leftCell.colSpan = "2";

    return leftCell;
}



/* Overlays */

var nrchanger;
function newnoderange() {
    var sel
    if (nrchanger) {
        clearTimeout(nrchanger);
    }
    var nnr = this.value;
    nrchanger = setTimeout(function() {
        noderange = nnr;
        while (mainpane.firstChild) {
            mainpane.removeChild(mainpane.firstChild);
        }
    // clear modal dialog if in DOM    
    var alertd = document.getElementsByClassName("modaldialog")[0];
    var bg = document.getElementsByClassName("modalbg")[0];
    if (alertd != null || alertd != undefined) {
        alertd.parentElement.removeChild(alertd);
        bg.parentElement.removeChild(bg);
    }
    
	var spinner = document.createElement('span');
	spinner.classList.add('fa');
	spinner.classList.add('fa-spin');
	spinner.classList.add('fa-spinner');
	mainpane.appendChild(spinner);
	var spinner = document.createElement('span');
	spinner.textContent = l('Initializing Rack View....');
	mainpane.appendChild(spinner);
        getNodeInfo();
    }, 1000);
}

function maketoolbar() {
    var toolrow = document.createElement('ul');
    toolrow.classList.add('toolbar', 'header');
    toolrow.appendChild(maketoollabel(l('Noderange:')));
    var nrinput = document.createElement('input');
    nrinput.classList.add('tool');
    nrinput.addEventListener('input', newnoderange.bind(nrinput));
    nrinput.value = (noderange == null || noderange == "") ? 'everything' : noderange;
    // if(noderange != null && noderange != "") nrinput.value = noderange;
    // else nrinput.value = 'everything';
    toolrow.appendChild(nrinput);
    //var pausebutton = document.createElement('button');
    //pausebutton.textContent = l('Pause');
    //pausebutton.addEventListener('click', pause.bind(pausebutton));
    //toolrow.appendChild(pausebutton);
    //nrinput.value = noderange;
    overlayselect = addToolMenu(toolrow, l('Overlay'), 'tachometer');
    for (var lab in overlaysensors) {
        addMenuItem(overlayselect, l(lab), setoverlay.bind(lab));
    }

    return toolrow;
}

//SH ADDED
function sortrow(){
	/*
	for (var rack in racks){
		document.getElementById("rackTable_"+ racks[rack]).remove();	
	}
        drawRacks(this.textContent.substr(0,3), this.textContent.substr(-1));
        drawEnclosures(); 
        colorNodes();

	*/
	var racks = document.getElementsByClassName("row" + this.textContent.substr(-1));
	var temp = new Array(racks.length);
	
	for(var i=0; i<racks.length; i++){
		temp[i] = racks[i];
	}
	for (var i=0; i<temp.length; i++){
		document.getElementsByClassName("row" + this.textContent.substr(-1))[0].remove();
           //     document.getElementById("rackTable_"+ racks[rack]).remove();
        }
	var button = document.getElementsByClassName("btn" + this.textContent.substr(-1))[0];
	for(var i=0; i<temp.length; i++){
		button.insertAdjacentElement('afterend', temp[i]);
  	}
	if (this.textContent.substr(0,3) =='Asc'){
		button.textContent = l('Descending Row ' + this.textContent.substr(-1));
	} else {
		button.textContent = l('Ascending Row ' + this.textContent.substr(-1));
	}
	
}
//-- SH ADDED

function setoverlay() {
    if (curroverlay === overlaysensors[this]) { return; }
    curroverlay = overlaysensors[this];
    overlayselect.header.labeltext.textContent = ' Overlay: {} '.l(this);
    if (fetchdata) {
            clearTimeout(fetchdata);
            fetchdata = null;
    }
    for (var nname in nodedivs) {
        nodedivs[nname].getElementsByTagName('span')[1].textContent = "";
        nodedivs[nname].style.background = 'lightgrey';
    }
    minvalue = null;
    maxvalue = null;
    colorNodes();
}



function generateColor(scale, cur) {
    var idx;
    if (scale === null) {
        scale = [[minvalue, 240], [maxvalue, 0]];
    }
    for (idx=0; idx < (scale.length - 1); idx++) {
        if (scale[idx][0] == null || cur < scale[idx+1][0]) {
            break;
        }
    }
    var maxent;
    if (idx == scale.length - 1) {
        maxent = scale[idx];
    } else {
        maxent = scale[idx+1];
    }
    var diff = maxent[0] - scale[idx][0];
    if (diff == 0) {
        diff = 1;
    }
    var degree = cur - scale[idx][0]; // offset into the range of temps
    var factor = degree / diff; // normalize to 0 to 1
    if (factor < 0) { factor = 0; }
    if (factor > 1) { factor = 1; }
    var maxhue = scale[idx][1];
    var minhue = maxent[1];
    var deltahue = maxhue - minhue;
    factor = ((1 - factor) * deltahue) + minhue; // 0 is red, 240 is blue, follow the hue wheel
    return "hsl(" + factor + ", 100%, 50%)";
}

function colorDiv(data) {
    var sensoridx = this[1];
    var thenoverlay = this[0];
    if (thenoverlay !== curroverlay)  { return; } // Cease drawing stale responses that would mess up
    if (!active) { return; }
    currdivs = [];
    for (var nname in data['databynode']) {
        if (!data['databynode'][nname].hasOwnProperty('sensors')) {
            continue;
        }
        var hotness = data['databynode'][nname].sensors[0].value;
        if (hotness == null) { continue; }
        var units = data['databynode'][nname].sensors[0].units;
        if (!nodedivs.hasOwnProperty(nname)) {
            continue;
        }
        if (minvalue === null || minvalue > hotness) { minvalue = hotness; }
        if (maxvalue === null || maxvalue < hotness) { maxvalue = hotness; }

        currdivs.push(nodedivs[nname]);
        nodedivs[nname].getElementsByTagName('span')[1].textContent = " --- " + hotness + units;
        nodedivs[nname].hotness = hotness;

        if (curroverlay.scale === null) {
             // auto-scale should recolor all currdivs
             currdivs.forEach(function(thediv) {
                  thediv.style.background = generateColor(curroverlay.scale, thediv.hotness);
             });
        } else {
             nodedivs[nname].style.background = generateColor(curroverlay.scale, hotness);
        }
    }
    if ('_requestdone' in data) {
        currdivs = [];
        fetchdata = setTimeout(colorNodes, 1500);
    }
}

function colorNodes() {
    fetchdata = null;
    if (!active) {
        return;
    }
    
    getRequest('/confluent-api/noderange/' + noderange + '/sensors/hardware/all/' + curroverlay['sensors'][0], colorDiv.bind([curroverlay, 0]));
}

function reload(json){
    if(json._requestdone){
        getNodeInfo();
    }    
}

function closerackview() {
    active = false;
}

function rackview() {
    clear_main();
    active = true;
    window.main = rackview;
    window.closemain = closerackview;
    var truemainpane = document.getElementById('main');
    truemainpane.appendChild(maketoolbar());
    mainpane = document.createElement('div');
    truemainpane.appendChild(mainpane);
	var spinner = document.createElement('span');
	spinner.classList.add('fa');
	spinner.classList.add('fa-spin');
	spinner.classList.add('fa-spinner');
	mainpane.appendChild(spinner);
	var spinner = document.createElement('span');
	spinner.textContent = l('Initializing Rack View....');
	mainpane.appendChild(spinner);
	

    if (!curroverlay) {
            curroverlay = overlaysensors['Ambient Temperature'];
            overlayselect.header.labeltext.textContent = ' Overlay: {} '.l('Ambient Temperature');
        }

    getNodeInfo();
    //drawRacks();
}

window.rackview = rackview;


/*window.onresize = function(event) {
	var h = window.innerHeight
		|| document.documentElement.clientHeight 
		|| document.body.clientHeight;
	if (h < 591){
		//document.getElementsByClassName("scroller")[0].parentNode.style.removeproperty("height");
		//document.getElementsByClassName("scroller")[0].parentNode.style.maxHeight = "89vh";
		document.getElementsByClassName("scroller")[0].parentNode.style.height = (h - 72) * 0.16 + "vh";
	} else {
		//document.getElementsByClassName("scroller")[0].parentNode.style.removeproperty("maxHeight");
		document.getElementsByClassName("scroller")[0].parentNode.style.height = "89vh";
	}

}*/


})();





