function buftob64(ins) {
	return btoa(String.fromCharCode(...new Uint8Array(ins))).replace(/\//g, '_').replace(/\+/g, '-')
}

function b64tobuf(inb) {
	inb = inb.replace(/_/g, '/').replace(/-/g, '+')
	return Uint8Array.from(atob(inb), c => c.charCodeAt(0))
}

async function register_webauthn() {
	args = await fetch_confluent('/confluent-api/sessions/current/webauthn/registration_options', {}, 'POST')
	args.challenge = b64tobuf(args.challenge);
	args.user.id = new TextEncoder().encode(args.user.id);
	cred = await navigator.credentials.create({publicKey: args});
	let credreq = {};
	credreq['attestation_object'] = buftob64(cred.response['attestationObject'])
	credreq['client_data_json'] = buftob64(cred.response['clientDataJSON'])
	result = await fetch_confluent('/confluent-api/sessions/current/webauthn/register_credential', credreq)
}

async function authenticate_webauthn(name) {
	authopts = await fetch_confluent('/confluent-api/sessions/current/webauthn/registered_credentials/' + name, {}, 'POST')
	console.log(authopts)
	authopts.challenge = b64tobuf(authopts.challenge)
	for (let i of authopts.allowCredentials) {
		i.id = b64tobuf(i.id)
	}
	authopts.userVerification = 'discouraged'
	let navcred = await navigator.credentials.get({publicKey: authopts});
	let credreq = {}
	credreq['raw_id'] = buftob64(navcred.rawId)
	navcred = navcred.response
	credreq['authenticator_data'] = buftob64(navcred['authenticatorData'])
	credreq['client_data_json'] = buftob64(navcred['clientDataJSON'])
	credreq['signature'] = buftob64(navcred.signature)
	credreq['user_handle'] = buftob64(navcred.userHandle)
	let authresult = await fetch_confluent('/confluent-api/sessions/current/webauthn/validate/' + name, credreq, 'POST')
	clear_auth(authresult)
}

